#ifndef VIDEO_CONTROLS_H
#define VIDEO_CONTROLS_H

#include "utilDLL.h"
#include <QtGui/QtGui>

//namespace util 
//{

class UTIL_API VideoControls : public QFrame {
    Q_OBJECT
public:
    VideoControls(QWidget *parent);
    virtual ~VideoControls();

    void setAutoHide(bool hide);
    bool autoHide() const { return m_autoHide; }
    bool isPlaying() const { return m_isPlaying; }
    bool isTracking() const { return m_isTracking; }

public slots:
    void setFrameCount(int nframes);
    void setCurrentFrame(int frame);
    void setPlayback(bool playing);
    void play();
    void pause();
    void toogle();

signals:
    void stepForward();
    void stepBack();
    void currentFrameChanged(int frame);
    void currentFrameTracked(int frame);
    void playbackChanged(bool playing);
    void playbackStarted();
    void playbackPaused();
    void trackingChanged(bool tracking);
    void trackingStarted();
    void trackingStopped();

protected slots:
    void handleSliderPressed();
    void handleSliderReleased();

protected:
    QHBoxLayout *m_hbox;
    bool m_autoHide;
    bool m_isPlaying;
    bool m_isTracking;
    QToolButton *m_prevButton;
    QToolButton *m_playButton;
    QToolButton *m_nextButton;
    QSlider *m_frameSlider;
    QSpinBox *m_frameEdit;
};

//} // util namespace

#endif //VIDEO_CONTROLS_H
